# PropModSemig

## What is PropModSemig

This Mathematica(tm. of Wolfram Research) package checks if an N^n semigroup, given by its minimal \
generating set and the set of gaps, is a proportionally modular semigroup, using the function:\
 IsNnProportionallyModularSemigroup

## Using the package

First you can import the package with:

<< PropModSemig.m

It is required to set the path to Normaliz program:

SetupNormaliz["~/lib/normaliz-3.6.3/bin/normaliz"]

And next, just run the function with the corresponding parameters:

mgs = {{0, 3}, {0, 4}, {1, 1}, {2, 1}, {4, 0}, {5, 0}, {5, 2}, 
   {6, 0}, {7, 0}};
gaps = {{0, 1, 0}, {0, 2, 0}, {0, 2, 1}, {0, 5, 0}, {1, 0, 0}, 
    {1, 2, 0}, {1, 3, 0}, {1, 6, 0}, {2, 0, 0}, {2, 0, 1}, {2, 3, 0}, 
    {3, 0, 0}, {3, 1, 0}, {3, 4, 0}, {4, 1, 0}};

IsNnProportionallyModularSemigroup[mgs, gaps]

Whose output is:

{829/256, 21/16, 113/16, 1589/1024, 39/128, 89/128, 1/4, 3/4}

